<?php
// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'unreglist'); 

// #################### PRE-CACHE TEMPLATES AND DATA ######################
// pre-cache templates used by all actions
$globaltemplates = array(
        'unreg',
        'unreg_bits',
        'unreg_search',
        'navbar',
		'pagenav',
);

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################
ini_set("display_errors",1);

$unregbits = '';
$user_count = '';
$nav = '';

//if do=search
if (isset($_POST['search_name']) && !empty($_POST['search_name'])) {
    $search_name = trim($_POST['search_name']);
} else {
    $search_name = '';
}
unset($_POST['search_name']);

//check permissions
$arr_perm = explode(",", $vbulletin->userinfo['membergroupids']);
if ((5 != $permissions['usergroupid']) && (6 != $permissions['usergroupid']) && (7 != $permissions['usergroupid']) && 
!in_array(5, $arr_perm) && !in_array(6, $arr_perm) && !in_array(7, $arr_perm)) {
    print_no_permission();
}
else {
    $navbits = array(); 
    $navbits[$parent] = construct_phrase($vbphrase[unreg_outtitle]);
    
    //to pagenav
    $vbulletin->input->clean_array_gpc('r', array(
        'perpage' => TYPE_INT,
        'page' => TYPE_INT
    ));
    if(empty($vbulletin->GPC['page'])) {
        $page = 1;
    } else {
        $page = $vbulletin->GPC['page'];
    }
    if(empty($vbulletin->GPC['perpage'])) {
        $perpage = 20;
    } else {
        $perpage = $vbulletin->GPC['perpage'];
    }
    //check $_GET['do']
    if (!isset($_GET['do']) || empty($_GET['do']) || ($search_name == '')) {
        //get full list without searching
        
        //load count unique pair "name-IP"
        $query_uc = $db->query_first_slave("
            SELECT COUNT(DISTINCT username, ipaddress, visible) as count
            FROM " . TABLE_PREFIX . "post
            WHERE userid = 0
        ");
        $uc = $query_uc['count'];
        //load full list
        $unreg_users_query = $db->query_read("
            SELECT DISTINCT username, ipaddress
            FROM " . TABLE_PREFIX . "post
            WHERE userid = 0 AND visible = 1
            ORDER BY dateline DESC
            LIMIT " . (($page-1) * $perpage) . ", " . $perpage . "
        ");
        if($db->num_rows($unreg_users_query))
        {
            //if found at least 1 row
            $user_arr = array();
            $ip_arr = array();
            while ($res = $db->fetch_array($unreg_users_query)) {
                array_push($user_arr, $res['username']);
                array_push($ip_arr, $res['ipaddress']);
            }
            for ($i = 0; $i < sizeof($user_arr); $i ++) {
                $name = $user_arr[$i];
                $ip = $ip_arr[$i];
                //load count posts for every users
                $query_count = $db->query_first_slave("
                    SELECT COUNT(*) as count_post, dateline
                    FROM " . TABLE_PREFIX . "post
                    WHERE username = '" . $name . "' AND ipaddress = '" . $ip . "' AND visible = 1 AND userid = 0
                    ORDER BY dateline DESC
                ");
                //encode pair "name-IP" with glue "***"
                $to_posts = $name . '***' . $ip;
                $name_encode = base64_encode($to_posts);
                //replace "+" to "---" for url
                $name_encode = str_replace('+', '---', $name_encode);
                //prepare date for template
                $unreg['username'] = $name;
                $unreg['ip'] = $ip;
                $unreg['count'] = $query_count['count_post'];
                $unreg['last_post'] = date("d.m.Y H:i:s", $query_count['dateline']);
                //fetch template
                eval('$unregbits .= "' . fetch_template('unreg_bits') . '";');
            }
            //for search at unreglist
            $action = $_SERVER['PHP_SELF'] . '?do=search';
            eval('$search .= "' . fetch_template('unreg_search') . '";');
            //add pagenav
            $pagenav = construct_page_nav($page, $perpage, $uc, "unreg.php?","");
        }
    } elseif ($_GET['do'] == 'search') {  
        //get list, where name like searching string
        
        //load count posts for users, where username like searching string
        $unreg_users_query = $db->query_read("
            SELECT DISTINCT username, ipaddress
            FROM " . TABLE_PREFIX . "post
            WHERE userid = 0 AND visible = 1 AND username LIKE '" . $search_name . "%'
            ORDER BY dateline DESC
        ");
        $count_us = $db->num_rows($unreg_users_query);
        //load list, where username like searching string
        if($db->num_rows($unreg_users_query)) {
            $user_arr = array();
            $ip_arr = array();
            while ($res = $db->fetch_array($unreg_users_query)) {
                array_push($user_arr, $res['username']);
                array_push($ip_arr, $res['ipaddress']);
            }
            eval('$unregbits .= "<tr align=\"center\">
                <td colspan=\"4\" class=\"alt1\">' . $vbphrase[unreg_results] . '<br />' . 
                $vbphrase[unreg_resfound] . $db->num_rows($unreg_users_query) . $vbphrase[unreg_resfound1] . '</td>
                </tr>";');
            for ($i = 0; $i < sizeof($user_arr); $i ++) {
                $name = $user_arr[$i];
                $ip = $ip_arr[$i];
                $name = str_replace("'", "\'", $name);
                $query_count = $db->query_first_slave("
                    SELECT COUNT(*) as count_post, dateline
                    FROM " . TABLE_PREFIX . "post
                    WHERE username = '" . $name . "' AND ipaddress = '" . $ip . "' AND visible = 1 AND userid = 0
                    ORDER BY dateline DESC
                ");
                //encode pair "name-IP" with glue "***"
                $to_posts = $name . '***' . $ip;
                $name_encode = base64_encode($to_posts);
                //replace "+" to "---" for url
                $name_encode = str_replace('+', '---', $name_encode);
                //prepare date for template
                $unreg['username'] = $name;
                $unreg['ip'] = $ip;
                $unreg['count'] = $query_count['count_post'];
                $unreg['last_post'] = date("d.m.Y H:i:s", $query_count['dateline']);
                //fetch template
                eval('$unregbits .= "' . fetch_template('unreg_bits') . '";');
            }
            //for search at unreglist
            $action = $_SERVER['PHP_SELF'] . '?do=search';
            eval('$search .= "' . fetch_template('unreg_search') . '";');
            eval('$unregbits .= "<tr align=\"center\">
                <td colspan=\"4\" class=\"alt1\"><a href=\"' . $_SERVER['PHP_SELF'] . '\">К полному списку</a></td>
                </tr>";');
        }
    }
    //add navbar
    $navbits = construct_navbits($navbits);
    eval('$navbar = "' . fetch_template('navbar') . '";');
    //actual main output template
    eval('print_output("' . fetch_template('unreg') . '");');
}
?> 